class Button1 {
    constructor(x, y, w, h, label, scene, callback, tipo = 1) {
        var scaleon = 1.05;
        var scaleoff = 1;
        this.tipo = tipo;

        this.button1 = scene.add
            .rectangle(x, y, w, h, CORES.branco)
            .setStrokeStyle(2, CORES.verde)
            .setOrigin(0.5)
            .setInteractive({
                useHandCursor: true,
            })
            .on("pointerup", () => this.click(callback))
            .on("pointerdown", () => this.button1.setScale(scaleon - 0.1))
            .on("pointerover", () => this.button1.setScale(scaleon))
            .on("pointerout", () => this.button1.setScale(scaleoff));

        this.label = scene.add
            .text(x, y, label, {
                fontFamily: "GothamBook",
                align: "center",
                wordWrap: { width: w - 5 },
                fixedHeight: 0,
            })
            .setTint(CORES.verde)
            .setOrigin(0.5)
            .setFontSize(22);
    }

    destroy() {
        this.button1.destroy();
        this.label.destroy();
    }

    desactivar() {
        this.button1.disableInteractive();
    }

    click(callback) {
        if (this.tipo == 2) {
            this.setFill();
        }
        this.button1.setScale(1);

        callback();
    }

    setFill() {
        this.button1.setFillStyle(CORES.verde);
        this.label.setTint(CORES.branco);
    }
    setUnfill() {
        this.button1.setFillStyle(CORES.branco);
        this.label.setTint(CORES.verde);
    }

    getX() {
        return this.button1.x;
    }
    getY() {
        return this.button1.y;
    }

    getWidth() {
        return this.button1.width;
    }
    getHeight() {
        return this.button1.height;
    }
}

class Button2 {
    constructor(x, y, name, name2, scene, callback) {
        var scaleon = 1.05;
        var scaleoff = 1.0;

        this.button1 = scene.add
            .image(x, y, name)
            .setOrigin(0.5)
            .setInteractive({
                useHandCursor: true,
            })
            .on("pointerup", () => callback())
            .on("pointerover", () => this.button1.setScale(scaleon))
            .on("pointerout", () => this.button1.setScale(scaleoff));

        this.button1.setScale(scaleoff);

        this.button2 = scene.add
            .image(x, y, name2)
            .setOrigin(0.5)
            .setInteractive({
                useHandCursor: true,
            })
            .on("pointerup", () => callback())
            .on("pointerover", () => this.button2.setScale(scaleon))
            .on("pointerout", () => this.button2.setScale(scaleoff));

        this.button2.setVisible(false);
        this.button2.setScale(scaleoff);
    }

    changespr(num) {
        this.button1.setVisible(false);
        this.button2.setVisible(false);
        if (num == 1) {
            this.button1.setVisible(true);
        } else {
            this.button2.setVisible(true);
        }
    }

    desactivar() {
        this.button1.disableInteractive();
        this.button2.disableInteractive();
    }

    destroy() {
        this.button1.destroy();
        this.button2.destroy();
    }
}
