class IntroScene extends Phaser.Scene {
    constructor() {
        super("introScene");
    }
    preload() {
        preloadgraf(this);

        this.load.image("bgintro1", "assets/images/imagem_inicial.png");
        this.load.image("bgfinal", "assets/images/imagem_final.png");
        this.load.image("bgjogo", "assets/images/fundo_quadro.png");
        this.load.image("bgjogo_uk", "assets/images/fundo_quadro_uk.png");
        this.load.image("certo", "assets/images/CERTO.png");
        this.load.image("errado", "assets/images/ERRADO.png");
        this.load.image("avancar", "assets/images/AVANCAR_01.png");
        this.load.image("avancar_on", "assets/images/AVANCAR_02.png");
        this.load.image("barra_icons", "assets/images/BARRA_ARRASTA.png");
        this.load.image("bt_pt", "assets/images/PT_01.png");
        this.load.image("bt_pt_on", "assets/images/PT_02.png");
        this.load.image("bt_en", "assets/images/ENG_01.png");
        this.load.image("bt_en_on", "assets/images/ENG_02.png");
    }

    create() {
        this.data = {};
        this.data.uk = [
            "DISTRACTION",
            "Read and analyze each sentence regarding the distration.\nSelect and drag each sentence to the corresponding field.",
        ];
        this.data.pt = [
            "DISTRAÇÃO",
            "ANALISA ATENTAMENTE CADA UMA DAS FRASES REFERENTE À distração.\nSELECIONA E ARRASTA CADA DEFINIÇÃO PARA O ESPAÇO CORRESPONDENTE.",
        ];

        this.lg = "pt";

        var difY = 140;

        this.add.image(0, 0, "bgintro1").setOrigin(0);
        this.add.image(249, 786, "barra_icons").setOrigin(0);

        this.label1 = this.add
            .text(80, 55, this.data[this.lg][0].toUpperCase(), {
                fontFamily: fontTxt1,
                align: "left",
            })
            .setTint(CORES.branco)
            .setOrigin(0)
            .setFontSize(80)
            .setShadow(2, 2, "rgba(0,0,0,0.5)", 0);

        this.label2 = this.add
            .text(
                80,
                this.label1.y + this.label1.height,
                this.data[this.lg][1].toUpperCase(),
                {
                    fontFamily: fontTxt1,
                    align: "left",
                }
            )
            .setTint(CORES.branco)
            .setOrigin(0)
            .setFontSize(24)
            .setShadow(2, 2, "rgba(0,0,0,0.5)", 0);

        this.bt_lguk = new Button2(
            100,
            830 - difY,
            "bt_en",
            "bt_en_on",
            this,
            () => this.escolhalg("uk")
        );

        this.bt_lgpt = new Button2(
            239,
            830 - difY,
            "bt_pt",
            "bt_pt_on",
            this,
            () => this.escolhalg("pt")
        );

        this.btavancar = new Button2(
            config.scale.width - 75,
            832 - difY,
            "avancar",
            "avancar_on",
            this,
            () => this.clickavancar()
        );

        this.separador = this.add
            .rectangle(
                0,
                0,
                config.scale.width,
                config.scale.height,
                CORES.branco
            )
            .setOrigin(0)
            .setAlpha(0)
            .setInteractive();

        this.escolhalg(this.lg);
    }

    clickavancar() {
        this.btavancar.changespr(2);
        this.btavancar.desactivar();
        this.bt_lgpt.desactivar();
        this.bt_lguk.desactivar();
        this.tweens.add({
            targets: this.separador,
            alpha: 1,
            duration: 500,
            onComplete: this.avancar.bind(this),
        });
    }

    avancar() {
        this.scene.start("jogoScene", {
            lg: this.lg,
            titulo: this.data[this.lg][0],
        });
    }

    escolhalg(lg) {
        this.lg = lg;
        switch (lg) {
            case "pt":
                this.bt_lguk.changespr(1);
                this.bt_lgpt.changespr(2);
                break;
            case "uk":
                this.bt_lguk.changespr(2);
                this.bt_lgpt.changespr(1);
                break;
            default:
                break;
        }

        this.label1.setText(this.data[this.lg][0].toUpperCase());
        this.label2.setText(this.data[this.lg][1].toUpperCase());
    }
}

class Controller extends Phaser.Scene {
    constructor() {
        super("jogoScene");

        this.indexperguntas = -1;
        this.totalperguntas = 0;
        this.dataP = [];

        this.sequencia = [4, 3, 5, 0, 1, 2];

        this.objPergunta;
        this.currentEstado = "";
        this.lg = "pt";

        this.contaRespCertas = 0;
        this.contaRespErradas = 0;

        this.container_iniX = 750;
        this.container_iniY = 840;

        this.numDoRectPorBaixo = 0;

        this.g_wrect = 1015;
        this.g_hrect = 76;
    }

    loaddata() {
        //------------------------------
        this.dataP[0] = {};
        this.dataP[0] = {
            pergunta_pt:
                "um processo cognitivo que focaliza e seleciona em cada momento a informação importante do que se passa à nossa volta (através dos sentidos) de modo a que o nosso cérebro não fique sobrecarregado com uma quantidade esmagadora de informação.",
            pergunta_uk:
                "cognitive process that focuses and selects at each moment important information from what is happening around us (through the senses) so that our brain is not overloaded with an overwhelming amount of information.",
            opcaocorreta: 1,
        };
        this.dataP[1] = {
            pergunta_pt:
                "são selecionados e processados diversos estímulos simultaneamente (e.g., como quando se conduz um automóvel e se fala ao telemóvel simultaneamente).",
            pergunta_uk:
                "several stimuli are selected and processed simultaneously (e.g., as when driving a car and talking on mobile phone simultaneously).",
            opcaocorreta: 2,
        };
        this.dataP[2] = {
            pergunta_pt:
                "Qualquer atividade que compete pela atenção do condutor durante a condução com o potencial de prejudicar o seu desempenho e de ter consequências graves para a segurança rodoviária.",
            pergunta_uk:
                "It occurs when attention is diverted away from activities needed for safe driving towards a competing activity.",
            opcaocorreta: 3,
        };
        this.dataP[3] = {
            pergunta_pt:
                "inclui quaisquer pensamentos que absorvam a atenção do condutor/ciclista/peão ao ponto em que deixam de ser capazes de conduzir/andar no ambiente rodoviário em segurança.",
            pergunta_uk:
                "occurs when attention is not focused on the primary driving task.",
            opcaocorreta: 4,
        };
        this.dataP[4] = {
            pergunta_pt:
                "atenção concentrada ou focada, seleciona-se e processa-se apenas um estímulo.",
            pergunta_uk: "only one stimulus is selected and processed.",
            opcaocorreta: 5,
        };
        this.dataP[5] = {
            pergunta_pt: "visual, auditiva, biomecânica (física) e cognitiva.",
            pergunta_uk: "Can be visual, auditory, physical and/or cognitive.",
            opcaocorreta: 6,
        };

        this.totalperguntas = this.dataP.length;
    }

    isNear(obj1, obj2) {
        var distancia = Phaser.Math.Distance.BetweenPoints(obj1, obj2);
        if (distancia < 250) {
            return true;
        } else {
            return false;
        }
    }

    isInside(obj1, obj2) {
        if (
            obj2.x > obj1.x - obj1.width * 0.5 &&
            obj2.x < obj1.x + obj1.width * 0.5 &&
            obj2.y > obj1.y - obj1.height * 0.5 &&
            obj2.y < obj1.y + obj1.height * 0.5
        ) {
            return true;
        } else {
            return false;
        }
    }

    create(arg) {
        this.lg = arg.lg;
        this.titulo = arg.titulo;
        this.loaddata();

        if (this.lg == "uk") {
            this.add.image(0, 0, "bgjogo_uk").setOrigin(0);
        } else {
            this.add.image(0, 0, "bgjogo").setOrigin(0);
        }

        this.rect1 = this.add
            .rectangle(
                374 + this.g_wrect * 0.5,
                90 + this.g_hrect * 0.5,
                this.g_wrect,
                this.g_hrect,
                CORES.branco
            )
            .setOrigin(0.5);

        this.bloco1 = new Bloco(this);
        this.bloco1.create(this.dataP, 0, this.lg, this.rect1);
        //----------------------------------
        this.rect2 = this.add
            .rectangle(
                374 + this.g_wrect * 0.5,
                186 + this.g_hrect * 0.5,
                this.g_wrect,
                this.g_hrect,
                CORES.branco
            )
            .setOrigin(0.5);

        this.bloco2 = new Bloco(this);
        this.bloco2.create(this.dataP, 1, this.lg, this.rect2);
        //----------------------------------
        this.rect3 = this.add
            .rectangle(
                374 + this.g_wrect * 0.5,
                280 + this.g_hrect * 0.5,
                this.g_wrect,
                this.g_hrect,
                CORES.branco
            )
            .setOrigin(0.5);
        this.bloco3 = new Bloco(this);
        this.bloco3.create(this.dataP, 2, this.lg, this.rect3);
        //----------------------------------
        this.rect4 = this.add
            .rectangle(
                374 + this.g_wrect * 0.5,
                375 + this.g_hrect * 0.5,
                this.g_wrect,
                this.g_hrect,
                CORES.branco
            )
            .setOrigin(0.5);
        this.bloco4 = new Bloco(this);
        this.bloco4.create(this.dataP, 3, this.lg, this.rect4);
        //----------------------------------
        this.rect5 = this.add
            .rectangle(
                374 + this.g_wrect * 0.5,
                470 + this.g_hrect * 0.5,
                this.g_wrect,
                this.g_hrect,
                CORES.branco
            )
            .setOrigin(0.5);
        this.bloco5 = new Bloco(this);
        this.bloco5.create(this.dataP, 4, this.lg, this.rect5);
        //----------------------------------
        this.rect6 = this.add
            .rectangle(
                374 + this.g_wrect * 0.5,
                565 + this.g_hrect * 0.5,
                this.g_wrect,
                this.g_hrect,
                CORES.branco
            )
            .setOrigin(0.5);
        this.bloco6 = new Bloco(this);
        this.bloco6.create(this.dataP, 5, this.lg, this.rect6);
        //----------------------------------
        this.events.on("gonext", () => this.mudaEstado("fx_entre_perg"), this);
        this.events.on("ev_certo", () => this.contaCerto(), this);
        this.events.on("ev_errado", () => this.contaErrado(), this);

        this.objPergunta = new ObjDraggable(this);

        this.mudaEstado("start");
    }

    mudaEstado(estado) {
        switch (estado) {
            case "start":
                this.fx_separador("fadeout");
                break;
            case "fx_entre_perg":
                if (this.indexperguntas + 1 == this.totalperguntas) {
                    this.fx_separador("fadein");
                } else {
                    this.mudaEstado("proxima");
                }
                break;
            case "proxima":
                this.goNextPergunta();
                break;
            case "pre_final":
                this.scene.start("finalScene", {
                    lg: this.lg,
                    certas: this.contaRespCertas,
                    erradas: this.contaRespErradas,
                    titulo: this.titulo,
                });
                break;
            default:
                break;
        }
        this.currentEstado = estado;
    }

    goNextPergunta() {
        this.indexperguntas++;

        var ii = this.sequencia[this.indexperguntas];
        this.objPergunta.start(this.dataP[ii], this.lg);
    }

    fx_separador(efx) {
        if (this.separador) {
            this.separador.x = 0;
        } else {
            this.separador = this.add
                .rectangle(
                    0,
                    0,
                    config.scale.width,
                    config.scale.height,
                    CORES.branco
                )
                .setOrigin(0)
                .setInteractive();
        }

        this.separador.setDepth(100);

        if (efx == "fadeout") {
            this.separador.setAlpha(1);
            if (this.tween) this.tween.stop();
            this.tween = this.tweens.add({
                targets: this.separador,
                alpha: 0,
                duration: 1000,
                onComplete: this.mudaEstado("proxima"),
            });
        } else if (efx == "fadein") {
            this.separador.setAlpha(1);
            if (this.tween) this.tween.stop();

            this.tween = this.tweens.add({
                targets: this.separador,
                alpha: 1,
                duration: 2000,
                onComplete: this.mudaEstado("pre_final"),
            });
        } else {
            this.separador.setAlpha(1);
            if (this.tween) this.tween.stop();
            this.tween = this.tweens.add({
                targets: this.separador,
                x: -config.scale.width,
                duration: 500,
                onComplete: this.mudaEstado("proxima"),
            });
        }
    }

    contaCerto() {
        this.contaRespCertas++;
        //dizer ao bloco para mostrar a frase
        var ii = this.sequencia[this.indexperguntas];
        var o = this.dataP[ii].opcaocorreta;
        switch (o) {
            case 1:
                this.bloco1.showFrase();
                break;
            case 2:
                this.bloco2.showFrase();
                break;
            case 3:
                this.bloco3.showFrase();
                break;
            case 4:
                this.bloco4.showFrase();
                break;
            case 5:
                this.bloco5.showFrase();
                break;
            case 6:
                this.bloco6.showFrase();
                break;

            default:
                break;
        }
    }
    contaErrado() {
        this.contaRespErradas++;
    }
}

class ObjDraggable {
    constructor(scene) {
        this.scene = scene;

        this.fundo = this.scene.add
            .rectangle(0, 0, 675, 45, CORES.laranja)
            .setOrigin(0.5);

        //pergunta
        this.txt_pergunta = this.scene.add
            .text(0, 0, "-----", {
                fontFamily: fontTxt2,
                align: "center",
                wordWrap: { width: this.fundo.width },
            })
            .setTint(CORES.preto)
            .setOrigin(0.5)
            .setFontSize(12);

        this.container = this.scene.add.container(
            this.scene.container_iniX,
            this.scene.container_iniY,
            [this.fundo, this.txt_pergunta]
        );
        this.container.setSize(this.fundo.width, this.fundo.height);

        this.scene.input.on(
            "drag",
            function (pointer, gameObject, dragX, dragY) {
                gameObject.x = dragX;
                gameObject.y = dragY;

                var lista = [
                    this.scene.rect1,
                    this.scene.rect2,
                    this.scene.rect3,
                    this.scene.rect4,
                    this.scene.rect5,
                    this.scene.rect6,
                ];

                for (var i = 0; i < lista.length; i++) {
                    var saida = this.scene.isInside(lista[i], gameObject);
                    if (saida) {
                        lista[i].setFillStyle(CORES.cinzento);
                        this.scene.numDoRectPorBaixo = i + 1;
                    } else {
                        lista[i].setFillStyle(CORES.branco);
                    }
                }
            }
        );

        this.scene.input.on(
            "dragend",
            function (pointer, gameObject, dragX, dragY) {
                for (var i = 0; i < 6; i++) {
                    this.scene["rect" + (i + 1)].setFillStyle(CORES.branco);
                    this.scene["rect" + (i + 1)].setAlpha(1);
                }

                var ii = this.scene.sequencia[this.scene.indexperguntas];
                if (
                    this.scene.dataP[ii].opcaocorreta ==
                    this.scene.numDoRectPorBaixo
                ) {
                    this.scene.events.emit("ev_certo");
                    gameObject.x = -500;

                    this.scene[
                        "rect" + this.scene.numDoRectPorBaixo
                    ].setFillStyle(CORES.verde);

                    this.scene.tweens.add({
                        targets:
                            this.scene["rect" + this.scene.numDoRectPorBaixo],
                        alpha: 0,
                        duration: 500,
                    });

                    this.scene.numDoRectPorBaixo = 0;
                } else {
                    this.scene.events.emit("ev_errado");
                    this.scene.tweens.add({
                        targets: gameObject,
                        x: this.scene.container_iniX,
                        y: this.scene.container_iniY,
                        duration: 200,
                    });

                    this.scene[
                        "rect" + this.scene.numDoRectPorBaixo
                    ].setFillStyle(CORES.vermelho);

                    this.scene.tweens.add({
                        targets:
                            this.scene["rect" + this.scene.numDoRectPorBaixo],
                        alpha: 0,
                        duration: 500,
                    });

                    this.scene.numDoRectPorBaixo = 0;
                }
            }
        );
    }
    start(data, lg) {
        this.container.x = this.scene.container_iniX;
        this.container.y = this.scene.container_iniY;

        this.container.setInteractive({ cursor: "grab" });
        this.txt_pergunta.setText(data["pergunta_" + lg].toUpperCase());
        this.scene.input.setDraggable(this.container);
    }
}

class Bloco {
    constructor(scene) {
        this.scene = scene;
        this.lista_frases = [];
    }

    create(data, i_perg, lg, rect) {
        this.lg = lg;

        var aa_fundo = this.scene.add
            .rectangle(0, 0, rect.width, rect.height, CORES.laranja)
            .setOrigin(0.5);

        var aa_txt_pergunta = this.scene.add
            .text(0, 0, data[i_perg]["pergunta_" + this.lg].toUpperCase(), {
                fontFamily: fontTxt2,
                align: "center",
                wordWrap: { width: aa_fundo.width },
            })
            .setTint(CORES.preto)
            .setOrigin(0.5)
            .setFontSize(12);

        this.lista_frases[0] = this.scene.add.container(
            rect.x,
            rect.y + aa_fundo.height * 0.5 - rect.height * 0.5,
            [aa_fundo, aa_txt_pergunta]
        );

        this.lista_frases[0].setAlpha(0);
    }

    showFrase() {
        this.scene.tweens.add({
            targets: this.lista_frases[0],
            alpha: 1,
            duration: 500,
            onComplete: this.gonext.bind(this),
        });
    }

    gonext() {
        this.index++;
        this.scene.events.emit("gonext");
    }
}

class FinalScene extends Phaser.Scene {
    constructor() {
        super("finalScene");
    }

    create(arg) {
        this.lg = arg.lg;
        this.titulo = arg.titulo;
        this.certas = arg.certas;
        this.erradas = arg.erradas;

        this.data = {};
        this.data.uk = [
            "CONGRATULATIONS. YOU HAVE COMPLETED THE distraction activity.",
        ];
        this.data.pt = ["PARABÉNS. COMPLETASTE O QUADRO Da distração."];

        this.add.image(0, 0, "bgfinal").setOrigin(0);

        this.rectangulo = this.add
            .rectangle(
                config.scale.width * 0.5,
                config.scale.height * 0.5 - 47,
                1062,
                560,
                CORES.branco
            )
            .setOrigin(0.5)
            .setAlpha(0.7);

        this.rectanguloverde = this.add
            .rectangle(
                config.scale.width * 0.5,
                this.rectangulo.y - 155,
                993,
                187,
                CORES.verdealface
            )
            .setOrigin(0.5);

        this.add
            .text(
                this.rectanguloverde.x,
                this.rectanguloverde.y,
                this.data[this.lg][0].toUpperCase(),
                {
                    fontFamily: fontTxt1,
                    fill: "#ffffff",
                    align: "center",
                    wordWrap: { width: this.rectanguloverde.width },
                }
            )
            .setOrigin(0.5)
            .setFontSize(32);

        var texto = "";
        if (this.lg == "pt") {
            texto =
                "CONSEGUISTE COMPLETAR EM " +
                (this.certas + this.erradas) +
                " TENTATIVAS, COM " +
                this.erradas;
            texto += this.erradas == 1 ? " ERRO." : " ERROS.";
        } else {
            texto =
                "YOU COMPLETED THE EXERCISE IN " +
                (this.certas + this.erradas) +
                " ATTEMPTS, WITH " +
                this.erradas;
            texto += this.erradas == 1 ? " ERROR." : " ERRORS.";
        }
        this.add
            .text(
                this.rectanguloverde.x,
                config.scale.height * 0.5,
                texto.toUpperCase(),
                {
                    fontFamily: fontTxt1,
                    fill: "#000000",
                    align: "center",
                    wordWrap: { width: this.rectanguloverde.width },
                }
            )
            .setOrigin(0.5)
            .setFontSize(22);

        var labelbt = "Tentar outra vez";
        if (this.lg == "uk") labelbt = "Try again";

        var bt = new Button1(
            this.rectangulo.x,
            this.rectangulo.y + 187,
            377,
            56,
            labelbt,
            this,
            () => this.clickBt(),
            2
        );

        this.separador = this.add
            .rectangle(
                0,
                0,
                config.scale.width,
                config.scale.height,
                CORES.branco
            )
            .setOrigin(0)
            .setInteractive();

        this.separador.setDepth(100);
        this.separador.setAlpha(1);

        this.tweens.add({
            targets: this.separador,
            alpha: 0,
            duration: 1000,
        });
    }

    clickBt() {
        location.reload();
    }
}
